package com.example.tfat.myapplication.navigationbar.actor

import android.content.Context
import android.content.DialogInterface
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v7.widget.LinearLayoutManager
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bomostory.sceneeditmodule.basicdata.Actor
import com.bomostory.sceneeditmodule.basicdata.Scene
import com.bomostory.sceneeditmodule.layermanagement.LayerAdapter
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.layer_management_fragment.view.*
import kotlin.collections.ArrayList

class ActorControlDialog : DialogFragment() {

    private var listener: DialogInterface.OnDismissListener? = null
    //private val layerListeners = ArrayList<View.OnClickListener>()
    private val layer1Data = ArrayList<Actor>()
    private val layer1Adapter = LayerAdapter(layer1Data)
    private val layer2Data = ArrayList<Actor>()
    private val layer2Adapter = LayerAdapter(layer2Data)
    private val layer3Data = ArrayList<Actor>()
    private val layer3Adapter = LayerAdapter(layer3Data)
    private val layer4Data = ArrayList<Actor>()
    private val layer4Adapter = LayerAdapter(layer4Data)
    private val layer5Data = ArrayList<Actor>()
    private val layer5Adapter = LayerAdapter(layer5Data)

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.layer_management_fragment, container).apply {
            layer1.apply {
                adapter = layer1Adapter
                layoutManager = LinearLayoutManager(context).apply {
                    orientation = LinearLayoutManager.HORIZONTAL
                }
            }
            layer2.apply {
                adapter = layer2Adapter
                layoutManager = LinearLayoutManager(context).apply {
                    orientation = LinearLayoutManager.HORIZONTAL
                }
            }
            layer3.apply {
                adapter = layer3Adapter
                layoutManager = LinearLayoutManager(context).apply {
                    orientation = LinearLayoutManager.HORIZONTAL
                }
            }
            layer4.apply {
                adapter = layer4Adapter
                layoutManager = LinearLayoutManager(context).apply {
                    orientation = LinearLayoutManager.HORIZONTAL
                }
            }
            layer5.apply {
                adapter = layer5Adapter
                layoutManager = LinearLayoutManager(context).apply {
                    orientation = LinearLayoutManager.HORIZONTAL
                }
            }
        }
    }

    override fun onDismiss(dialog: DialogInterface?) {
        super.onDismiss(dialog)
        listener?.onDismiss(dialog)
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
        if (context is DialogInterface.OnDismissListener) {
            listener = context
        } else {
            throw RuntimeException(context.toString() + " must implement OnFragmentInteractionListener")
        }
    }

    override fun onDetach() {
        super.onDetach()
        listener = null
    }

    fun setData(scene: Scene){
        this.layer1Data.apply {
            clear()
            addAll(scene.layers[0].actors)
        }
        this.layer2Data.apply {
            clear()
            addAll(scene.layers[1].actors)
        }
        this.layer3Data.apply {
            clear()
            addAll(scene.layers[2].actors)
        }
        this.layer4Data.apply {
            clear()
            addAll(scene.layers[3].actors)
        }
        this.layer5Data.apply {
            clear()
            addAll(scene.layers[4].actors)
        }
    }
}