package com.bomostory.sceneeditmodule.layermanagement

import android.graphics.drawable.Drawable
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bomostory.sceneeditmodule.basicdata.Actor
import com.example.tfat.myapplication.R
import kotlinx.android.synthetic.main.actor_item.view.*


class LayerAdapter (var data: ArrayList<Actor>) : RecyclerView.Adapter<LayerAdapter.ViewHolder>() {
    override fun getItemCount(): Int {
        return data.size
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(data[position])
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v1 = LayoutInflater.from(parent.context).inflate(R.layout.actor_item, parent, false)
        return ViewHolder(v1)
    }

    class ViewHolder (view : View) : RecyclerView.ViewHolder(view) {
        fun bind(actor: Actor) {
            itemView.actor_image.setImageDrawable(Drawable.createFromPath(actor.resourcePath))
        }
    }
}